SystemOrganization addCategory: #'JiffyCard-Core'!

ALApplication subclass: #JiffyCardApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JiffyCardApplication methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2017 07:22'!
initializeLocator
	locator 
		at: ALPath root 
		put: JCDeckOne new asResource
		
	
	" (JCMessage new message: 'The Ghost In The Machine')"! !

Object subclass: #JCController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

JCController subclass: #JCComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

JCComponent subclass: #JCCard
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCCard methodsFor: 'accessing' stamp: 'chc 7/5/2017 07:22'!
owner

	^ owner! !

!JCCard methodsFor: 'accessing' stamp: 'chc 7/5/2017 07:22'!
owner: anObject

	owner := anObject! !

JCCard subclass: #JCCounterExample
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCCounterExample methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:25'!
initialize
	super initialize.
	count := 0! !

!JCCounterExample methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:25'!
renderContentOn: html
	html a 
		class: 'action';
		navigate: [count := count - 1]; 
		with: '--'.
	html span
		class: 'counter';
		with: count asString.
	html a 
		class: 'action';
		navigate: [count := count + 1]; 
		with: '++'.
	html br. 
	html a callback: [ owner nextCard]; with: 'Next Card'! !

JCCard subclass: #JCFormExample
	instanceVariableNames: 'integer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCFormExample methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:26'!
initialize
	integer := 0! !

!JCFormExample methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:26'!
renderContentOn: html
	html form beMethodGet; with:
		[html input 
			beTypeText
			value: integer printString;
			callback: [:str | integer := str asNumber];
			with: [].
		html text: integer asWords]! !

!JCFormExample methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:26'!
renderStyleOn: html
	html style: 'input {margin-right: 20px}'! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 6/30/2017 09:27'!
addDecoration: newDecoration
	| dec |
	dec _ self decoration.
	newDecoration next: dec.
	self decoration: newDecoration! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 6/30/2017 09:27'!
decoration
	^ decoration! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 6/30/2017 09:27'!
decoration: anObject
	decoration := anObject! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 5/30/2017 12:46'!
initialize
	decoration := self! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 6/30/2017 09:27'!
removeDecoration
	| owner |
	owner _ self decoration next.
	self decoration: owner! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 4/26/2017 10:05'!
renderContentOn: anObject
	self subclassResponsibility ! !

JCComponent subclass: #JCDeck
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDeck methodsFor: 'converting' stamp: 'chc 6/29/2017 07:08'!
asResource
	^ JCHtmlResource component: self! !

!JCDeck methodsFor: 'rendering' stamp: 'chc 7/1/2017 08:28'!
initialize
	stack := Stack new.
	self deck do: [:ea| stack push: (ea new owner: self)].
	self addDecoration: (JCDelegation new delegate: stack pop)! !

!JCDeck methodsFor: 'rendering' stamp: 'chc 7/1/2017 08:31'!
nextCard
	|card decoration|
	card := stack pop. "cart: cart".
	decoration := JCDelegation new delegate: card.
	self removeDecoration.
	self addDecoration: decoration
	! !

!JCDeck methodsFor: 'rendering' stamp: 'chc 6/29/2017 07:08'!
renderBodyOn: html
	html div
		with: [decoration renderOn: html]! !

!JCDeck methodsFor: 'rendering' stamp: 'chc 6/29/2017 07:08'!
renderHtmlOn: html
	html html: 
		[html head: 
			[html title: 'JiffyCard'.
			 html style: 
				'#border {
					border: thin solid #aaa;
					margin-left: 8px;
					margin-right: 8 px;}'].
	html body: [ self renderBodyOn: html ] ]! !

!JCDeck methodsFor: 'accessing' stamp: 'chc 7/1/2017 08:23'!
stack

	^ stack! !

!JCDeck methodsFor: 'accessing' stamp: 'chc 7/1/2017 08:23'!
stack: anObject

	stack := anObject! !

JCDeck subclass: #JCDeckOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDeckOne methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:27'!
deck
 	^{JCFormExample.
	   JCCounterExample
	   }! !

!JCController methodsFor: 'rendering' stamp: 'chc 5/30/2017 12:51'!
renderOn: html
	"( self respondsTo: #decoration)
		ifTrue: [  self decoration renderContentOn: html   ]
		ifFalse: [ " self renderContentOn: html   " ]"! !

JCController subclass: #JCDecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDecoration methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:14'!
next

	^ next! !

!JCDecoration methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:14'!
next: anObject

	next := anObject! !

!JCDecoration methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 21:10'!
renderContentOn: anObject
	self subclassResponsibility ! !

JCDecoration subclass: #JCDelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDelegation commentStamp: 'chc 5/30/2017 13:31' prior: 0!
This is a different kind of decoration. Instead of adding content or a window, which will pass on to the next decoration or the owner in the #next ivar. There is a component in the delegate ivar that replaces the original owner component. When this decoration is removed the original owner re-renders. 

It needs to go one step further. The delegate needs to be passed a self delegate reference (see Kent Beck "Smalltalk Best Practices") so that the component can have an anchor that can reach this decoration to send #remove. !

!JCDelegation methodsFor: 'accessing' stamp: 'chc 5/30/2017 13:21'!
delegate

	^ delegate! !

!JCDelegation methodsFor: 'accessing' stamp: 'chc 5/30/2017 13:21'!
delegate: anObject

	delegate := anObject! !

!JCDelegation methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 13:21'!
renderContentOn: html 
	html render: delegate! !

JCDecoration subclass: #JCMessage
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCMessage methodsFor: 'accessing' stamp: 'chc 5/30/2017 13:26'!
message: anObject

	message := anObject! !

!JCMessage methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 13:26'!
renderContentOn: html
	html p: message.
	next renderContentOn: html ! !

ALComponentResource subclass: #JCHtmlResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:49'!
handleGet: aRequest locator: aLocator
	| response |
	response := self respondHtmlLocator: aLocator.
	response vary: (ALStrings with: 'Accept').
	^ response! !

!JCHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:48'!
respondHtmlLocator: aLocator
	 ^ ALResponse 
		type: ALContentType html 
		callback: 
			[:out || context |
			context := ALRenderingContext resource: self locator: aLocator.
			component renderHtmlOn: (ALAppHtml5Canvas context: context stream: out)]! !
